#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: 01_vbq_network_init.pl, v1.0.0.0 Thu 12 Apr 2007 12:49:03 AM CEST mstauber Exp $
# Copyright 2007 Solarspeed Ltd. All rights reserved.
#
# Script to populate CCE with the propper network settings under CCE. Without this
# every CCE restart would fuck up the routing and make this VPS unreachable.

use CCE;
#use Sys::Hostname;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

# Parse /etc/sysconfig/network-scripts/ifcfg-venet0
$venet_zero = '/etc/sysconfig/network-scripts/ifcfg-venet0';
if (-e $venet_zero) {
    open(FILE,"$venet_zero") || die("Could not find $venet_zero. $!");
    while ($line = <FILE>) {
        chomp($line);
        next if $line =~ /^\s*$/; # skip blank lines
        if ($line =~ /^IPADDR=(.*)/) {
            $ipaddress = $1;
        }
        if ($line =~ /^NETMASK=(.*)/) {
            $netmask = $1;
        }
    }
    close(FILE);
}

# Parse /etc/sysconfig/network
$nwfile = '/etc/sysconfig/network';
if (-e $nwfile) {
    open(NFILE,"$nwfile") || die("Could not find $nwfile. $!");
    while ($line = <NFILE>) {
        chomp($line);
        next if $line =~ /^\s*$/; # skip blank lines
        if ($line =~ /^GATEWAY=(.*)/) {
            $defaultgw = $1;
        }
        if ($line =~ /^GATEWAY=\"(.*)\"/) {
            $defaultgw = $1;
        }
    }
    close(NFILE);
}

# Get host and domain name: (not needed as long as we do not need/want to bypass wizard)
#$fqdn = hostname();
#(@fqdnparts) = split (/\./, $fqdn);
#$host = $fqdnparts[0];
#(@domainhelper) = split (/$host\./, $fqdn);
#$domain = $domainhelper[1];

# Parse /etc/resolv.conf
$rwfile = '/etc/resolv.conf';
if (-e $rwfile) {
    open(RFILE,"$rwfile") || die("Could not find $rwfile. $!");
    while ($line = <RFILE>) {
        chomp($line);
        next if $line =~ /^\s*$/; # skip blank lines
        if ($line =~ /^nameserver (.*)/) {
            $nameserver = $1;
        }
    }
    close(RFILE);
}

$cce->connectuds();

# Populate CCE with the new info:
($sys_oid) = $cce->find('Network', {'device' => 'venet0'});
if ($sys_oids < 0) {
        print "Object 'System' not found in CCE.\n";
    }
    else {
        ($ok) = $cce->set($sys_oid, '',{
            'ipaddr' => $ipaddress,
            'netmask' => $netmask,
            'device' => 'venet0'
        });
}
($sys_oid) = $cce->find('System', '');
if ($sys_oids < 0) {
        print "Object 'System' not found in CCE.\n";
    }
    else {
        ($ok) = $cce->set($sys_oid, '',{
            'gateway' => $defaultgw
        });
}

# Set CCE Object "Disk" to /def/simfs:
($sys_oid) = $cce->find('Disk', '');
if ($sys_oids < 0) {
        print "Object 'Disk' not found in CCE.\n";
    }
    else {
        ($ok) = $cce->set($sys_oid, '',{
            'device' => '/dev/simfs'
        });
}

# Goodbye!
$cce->bye('SUCCESS');
exit(0);


